<?php 

class NoSeriesManagement extends baseclass{
	function getNextNo($series_code,$commit=false){
            // получаем объект Таблица из БД
      		$no_series = $this->getTable('no_series');
            // выставляем фильтр по полученному коду
           	$no_series->setFilter('code','=',$series_code);
            // если нет настроек с таким кодом, то выходим
          	if(!$no_series->getFirstRow())return null;
            
            // служебные переменные, где собираемся хранить значения
			$last_no = null;
            $next_no = null;
            
            //если в таблице последний использованный номер отсутствует, то инициализируем стартовым номером
            // иначе берем последний использованный номер из серии и увеличиваем последний использованный на шаг серии
            if(is_null($no_series->get_Last_no_used())||($no_series->get_Last_no_used()=='')){
            	$last_no=$no_series->get_Starting_no();
              	$next_no=$last_no;
            } else{
            	$last_no = $no_series->get_Last_no_used();
 	         	$next_no = $this->incstr($last_no,$no_series->get_Increment(),$no_series->get_Ending_no());
            }
            // проставляем последний использованный номер в рамках транзакции
            $no_series->set_Last_no_used($next_no);
            $no_series->update($commit);  
          	//возвращаем следующий номер для запрошенной серии номеров
          	return $next_no;
        
        }
		
  
  private function incstr($string,$increment,$max_no=null){
			if(is_null($string)||($string=='')) return null;
			
			$separated_arr = $this->separateBaseAndDigits($string);
			if(!is_null($max_no)){ // проверка что остались еще номера
            	$max_separated = $this->separateBaseAndDigits($max_no);
              	if(intval($separated_arr['digits'])>(intval( $max_separated['digits'])-$increment)){
                	throw new Exception('Серия номеров предел '.$max_no.' достигнут.');
                }
            }
			$digits_portion = intval( $separated_arr['digits'] + $increment);
			$add_zeros='';
			$count=$separated_arr['number_digits']-strlen($digits_portion);
			for($k=0;$k<$count;$k++){
				
				$add_zeros.='0';
				}
			
			return $separated_arr['base'].$add_zeros.$digits_portion;
		
		}
  	
  private function separateBaseAndDigits($string){
        	$tailing_number_digits =  0;
			$i = 0;
			$from_end = -1;
			
			while ( $i < strlen($string) ) {
				if ( is_numeric( substr( $string,$from_end - $i, 1 ) ) ) {
					$tailing_number_digits++;
				}
				else{
					// Заканчиваем цикл если нет номеров в строке
					break;
				}
				$i++;
			}		
			
			$base_portion = $string;
			$digits_portion = '';
			
			if ( $tailing_number_digits > 0 ) {
				$base_portion = substr( $string, 0, -$tailing_number_digits );
				$digits_portion = abs(substr( $string, -$tailing_number_digits ));	
			}
          
          	return array('base'=>$base_portion,'digits'=>$digits_portion,'number_digits'=>$tailing_number_digits);
        
        }
  
  
	} 

?>
