<?php 

class Route {
	public static function Start(){
		$uri = explode('?',$_SERVER['REQUEST_URI']);
		$routes = explode('/', $uri[0]);
		$route = $routes[1];
		switch ($route) {
			case '':
			case 'login':
				self::login();
				break;
			case 'menu':
				self::menu();
				break;
			case 'form':
				self::formrun();
				break;
			case 'data':
				self::data();
				break;
			case 'class':
				self::classrun();
				break;
			case 'report':
				self::reportrun();
				break;
			case 'logout' :
				self::logout();
				break;
			default : die();	
		}
		
	}
	
	private static function login(){
		if(security::userLogedIn()){
				header("location: menu");
				return;
			}
		
		if(security::requestMethod() == 'POST'){
			security::login();
			
			if(security::userLogedIn()){
			 	header("location: menu");
			}else{
				header("location: login?error=1");
		    }
		}
			
		include security::viewsPath().'login_view.php';
		
	}
	
   private static function menu(){
	 self::checkLogin();
	 
	 include_once security::classesPath().'baseclass.php';
	 include_once security::classesPath().'utils.php';
	 include_once security::settingPath().'tableFactory.php';
	 include security::viewsPath().'menu_view.php';
	 
   }
   
   private static function logout(){
		session_start();
		$_SESSION = [];
		session_destroy();  
		header("location: login");
   }
   
   private static function data(){
	 include_once security::settingPath().'tableFactory.php';
	 include_once security::enginePath().'data.php';
	 Data::run();
   }
   
   private static function classrun(){
	 include_once security::settingPath().'tableFactory.php';
	 include_once security::classesPath().'baseclass.php';
	 include_once security::enginePath().'class.php';   
	 Classrun::run();
	   
   }
   
   private static function reportrun(){
	 include_once security::settingPath().'tableFactory.php';
	 include_once security::reportsPath().'report.php';
	 include_once security::enginePath().'reportrun.php';
	 Reportrun::run();
  }
  
  private static function formrun(){
	  self::checkLogin();
	  include_once security::enginePath().'formrun.php';
	  Formrun::run();
  }
  
  private static function checkLogin(){
	  if(!security::userLogedIn()){
		header("location: login");
		return;
	 }
  }
}

?>
