<?php
//все функции должны быть статические
class security{
	private const HOSTNAME = 'localhost'; 
	private const USERNAME = ''; // пользователь
	private const PASSWORD = ''; // пароль
	const DATABASE = '';	// имя БД
	
	public static function enginePath(){
			return __DIR__.'/';
		}
	
	public static function formsPath(){
		    return self::enginePath().'forms/';
		}
	
	public static function tablesPath(){
		   return self::enginePath().'modules/data/tables/';
		}
	
	public static function reportsPath(){
		   return self::enginePath().'modules/reports/';
		}
	
	public static function reportTemplatesPath(){
		   return self::enginePath().'modules/reports/templates/';
		}
	
	public static function classesPath(){
		   return self::enginePath().'modules/classes/';
		}
	
	public static function settingPath(){
		   return self::enginePath().'modules/data/';	
		}
	public static function viewsPath(){
		   return self::enginePath().'views/';	
		}
	
	private static function setSessionTablesPermissions($userid, $username, $mysqli){
			if($username=='admin'){return;}
			
			$roles_arr = self::getUserRoles($userid,$mysqli);
			if(empty($roles_arr)) {return;}
			$roles = implode(',',array_filter(array_column($roles_arr,0)));
			$query = "SELECT b.name, max(a.allow_select) as allow_select, max(a.allow_insert) as allow_insert, max(a.allow_update) as allow_update, max(a.allow_delete) as allow_delete  FROM sys_roles_tables a,sys_tables b where a.tableid=b.id and a.roleid in ($roles) group by name"; 
			$result = $mysqli->query($query);
			$rights=array();
			while ($row = $result->fetch_assoc()){
					$rights[$row['name']]= array(	's'=>($row['allow_select']==1),
													'i'=>($row['allow_insert']==1),
													'u'=>($row['allow_update']==1),
													'd'=>($row['allow_delete']==1)
					);
				}
			$_SESSION['tr'] = $rights;	
	}
	
	private static function setSessionMenuItemPermissions($userid, $username, $mysqli){
			if(self::isAdmin())return;
			$roles_arr = self::getUserRoles($userid,$mysqli);
			if(empty($roles_arr)) {return;}
			$roles = implode(',',array_filter(array_column($roles_arr,0)));
			$query = "SELECT menuitemid FROM sys_role_menuitems where roleid in ($roles) group by menuitemid"; 
			$result = $mysqli->query($query);
			$menuitems = array();
			while ($row = $result->fetch_assoc()){
				$menuitems[]=$row['menuitemid'];
			}
			$_SESSION['menuitems'] = $menuitems;
	}
	
	public static function hasPermissionOnMenuItem($menuitemid){
			if(self::isAdmin())return true;
			return in_array($menuitemid, $_SESSION['menuitems']);
	}
	
	public static function isAdmin(){
		return ($_SESSION['username']=='admin');
		}
	
	public static function getUserRoles($userid, $mysqli){
			$query = "SELECT role FROM sys_user_roles WHERE user = $userid";
			$result = $mysqli->query($query);
			return $result->fetch_all();
	}
	public static function hasPermissionOnTable($tablename, $righttype='s'){
		if(self::isAdmin())return true;
		return isset($_SESSION['tr'])&&isset($_SESSION['tr'][$tablename])&&($_SESSION['tr'][$tablename][$righttype]);
	}
	
	public static function allowRequest(){
		if(!($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest'))
			{
				return false;
			}  
		// проверка на запросы с других доменов
		if (self::requestMethod() == "POST") {
			if (isset($_SERVER["HTTP_ORIGIN"])) {
				$protocol = self::isSecure()?'https':'http';
				$address = $protocol."://".$_SERVER["SERVER_NAME"];
				$addr_pos = strpos($address, $_SERVER["HTTP_ORIGIN"]);
				$addr_length = strlen($address);
				if (($addr_pos !== 0)&&($addr_pos<$addr_length))
				{
					return false;
				}
			}else{return false;} 
		}
		if(!isset($_SESSION))session_start();
		if(!isset($_SESSION['userid'])){return false;}
		return true;
	}
	
	public static function userId(){
		if(!isset($_SESSION))session_start();
		return (isset($_SESSION['userid']))?$_SESSION['userid']:null;
		}
	public static function userName(){
		if(!isset($_SESSION))session_start();
		return (isset($_SESSION['username']))?$_SESSION['username']:null;
		}
	public static function userLogedIn(){
		return !is_null(self::userId());
		}
	public static function cryptpwd($pass){
			return md5(''.$pass); //сюда добавить "соль" для устойчивости пароля md5('add Salt here'.$pass);
		}	
	public static function requestMethod(){
		return $_SERVER["REQUEST_METHOD"];
		}	
	
	private static function isSecure() {
		return (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off')|| $_SERVER['SERVER_PORT'] == 443;
	}
	
	public static function login(){
		session_start();
		if(self::userLogedIn()) return;
		
		$mysqli = self::conn();
		$myusername = $mysqli->real_escape_string($_POST['username']);
		$mypassword = self::cryptpwd($mysqli->real_escape_string($_POST['password'])); 
		  
		$sql = "SELECT id FROM sys_users WHERE username = '$myusername' and password = '$mypassword'";
		$result = $mysqli->query($sql);
		$row = $result->fetch_assoc();
			
		if(!is_null($row)) {
		 $user = $row['id'];
		 $_SESSION['userid'] = $user;
		 $_SESSION['username'] = $myusername;
		 self::setSessionTablesPermissions($user, $myusername, $mysqli);
		 self::setSessionMenuItemPermissions($user, $myusername, $mysqli);
		 self::setSessionUserTheme($mysqli);
		}
		
	}
	
	public static function conn(){
		$mysqli = new mysqli(self::HOSTNAME, self::USERNAME, self::PASSWORD, self::DATABASE);
		if (mysqli_connect_errno())
			{
			die("Connection to database is lost.");
		}
		$mysqli->set_charset("utf8mb4");
		return $mysqli;
	} 
	
	private static function setSessionUserTheme($mysqli){
			include (self::settingPath().'table.php');

			if(!isset($_SESSION['usertheme'])){
				$viewsettings= new Table('viewsettings', $mysqli);
				$viewsettings->setFilter('userid','=', self::userId());
				$viewsettings->getFirstRow();
				$themeid = $viewsettings->get_Themeid();
				$theme= new Table('themes', $mysqli);
				
				if(is_null($themeid)){
					$theme->getFirstRow();
				}else{
					$theme->getById($themeid);
				};
				
				
				if(is_null($viewsettings->get_I18n())){
					$_SESSION['i18n'] = 'ru';
					$_SESSION['i18n_lang'] = 'ru-RU';
				}else
				{
					$i18n = new Table('i18n', $mysqli);
					$i18n->getById($viewsettings->get_I18n());
					$_SESSION['i18n'] = $i18n->get_Culture();
					$_SESSION['i18n_lang'] = $i18n->get_Language();
				}
				
				$_SESSION['usertheme']=$theme->get_Theme_name();
			}
		
	}
	
	public static function userTheme(){
		return $_SESSION['usertheme'];
	}
	
	public static function i18n(){
		return $_SESSION['i18n'];
	}
	
	public static function i18n_lang(){
		return $_SESSION['i18n_lang'];
	}
}
