-- MySQL dump 10.13  Distrib 5.7.39, for Linux (x86_64)
--
-- Host: localhost    Database: example_db
-- ------------------------------------------------------
-- Server version	5.7.39-0ubuntu0.18.04.2

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `bin`
--

DROP TABLE IF EXISTS `bin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bin` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(45) DEFAULT NULL,
  `description` varchar(450) DEFAULT NULL,
  `location` int(11) DEFAULT NULL,
  `zone` int(11) DEFAULT NULL,
  `bintype` int(11) DEFAULT NULL,
  `cubage` int(11) DEFAULT '0',
  `maximum_weight` int(11) DEFAULT '0',
  `block_movement` tinyint(4) DEFAULT '0',
  `empty` tinyint(4) DEFAULT '0',
  `binranking` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `fk_bin_1_idx` (`location`),
  KEY `fk_bin_2_idx` (`zone`),
  KEY `fk_bin_3_idx` (`bintype`),
  CONSTRAINT `fk_bin_1` FOREIGN KEY (`location`) REFERENCES `location` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_bin_2` FOREIGN KEY (`zone`) REFERENCES `zone` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_bin_3` FOREIGN KEY (`bintype`) REFERENCES `bintypes` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bin`
--

LOCK TABLES `bin` WRITE;
/*!40000 ALTER TABLE `bin` DISABLE KEYS */;
INSERT INTO `bin` VALUES (1,'А','Приемка',1,1,1,0,0,0,0,0),(2,'B-01-0001','Хранение',1,2,2,20,450,0,0,0),(3,'B-01-0002','Хранение',1,2,2,40,1000,0,0,0),(4,'B-02-0001','Хранение',1,2,2,30,600,0,0,0),(5,'ГОТ-01','Для готовых заказов',1,3,3,0,0,0,0,0);
/*!40000 ALTER TABLE `bin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bintypes`
--

DROP TABLE IF EXISTS `bintypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bintypes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(10) DEFAULT NULL,
  `description` varchar(45) DEFAULT NULL,
  `receive` tinyint(4) DEFAULT '0',
  `ship` tinyint(4) DEFAULT '0',
  `put_away` tinyint(4) DEFAULT '0',
  `pick` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bintypes`
--

LOCK TABLES `bintypes` WRITE;
/*!40000 ALTER TABLE `bintypes` DISABLE KEYS */;
INSERT INTO `bintypes` VALUES (1,'ПРИЕМКА','Приемка до сортировки',1,0,0,0),(2,'ПОДБОР','Подбор/хранение товара',0,1,1,1),(3,'ОТГРУЗКА','Отгрузка готовых заказов',0,1,0,0);
/*!40000 ALTER TABLE `bintypes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `brands`
--

DROP TABLE IF EXISTS `brands`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `brands` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(450) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=41 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `brands`
--

LOCK TABLES `brands` WRITE;
/*!40000 ALTER TABLE `brands` DISABLE KEYS */;
INSERT INTO `brands` VALUES (1,'Красная Звезда'),(2,'Ижмебель'),(3,'ТриЯ'),(4,'Орматек'),(5,'Аскона'),(6,'Боровичи-Мебель'),(7,'Мебелик'),(8,'Олимп-мебель'),(9,'Райтон'),(10,'СКАНД МЕБЕЛЬ'),(11,'Нижегородмебель и К'),(12,'Столики детям'),(13,'Барро'),(14,'Арника'),(15,'Мэрдэс'),(16,'Формула мебели'),(17,'Аквилон'),(18,'Мебель-Неман'),(19,'Фант Мебель'),(20,'Пирамида'),(21,'Глазовмебель'),(22,'Интерьер-Центр'),(23,'Баронс'),(24,'МебельГрад'),(25,'Волшебная сосна'),(26,'Бельмарко'),(27,'Этажерка'),(28,'Ваша Мебель'),(29,'ГайваМебель'),(30,'Мелания'),(31,'Наша мебель'),(32,'Форвард-мебель'),(33,'4 Сезона'),(34,'Русский Лес'),(35,'СБК'),(36,'MEBELSON'),(37,'SIGNAL'),(38,'Ярофф'),(39,'Stolline'),(40,'Cilek');
/*!40000 ALTER TABLE `brands` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `company_info`
--

DROP TABLE IF EXISTS `company_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `company_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) DEFAULT NULL,
  `address` varchar(200) DEFAULT NULL,
  `city` varchar(45) DEFAULT NULL,
  `postcode` varchar(45) DEFAULT NULL,
  `phone` varchar(45) DEFAULT NULL,
  `phone2` varchar(45) DEFAULT NULL,
  `email` varchar(45) DEFAULT NULL,
  `bank_name` varchar(45) DEFAULT NULL,
  `giro_no` varchar(45) DEFAULT NULL,
  `bank_branch_no` varchar(45) DEFAULT NULL,
  `bank_account_no` varchar(45) DEFAULT NULL,
  `payment_routing_no` varchar(45) DEFAULT NULL,
  `vat_registration_no` varchar(45) DEFAULT NULL,
  `ship_to_name` varchar(200) DEFAULT NULL,
  `ship_to_address` varchar(200) DEFAULT NULL,
  `ship_to_city` varchar(45) DEFAULT NULL,
  `ship_to_postcode` varchar(45) DEFAULT NULL,
  `iban` varchar(45) DEFAULT NULL,
  `swift_code` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `company_info`
--

LOCK TABLES `company_info` WRITE;
/*!40000 ALTER TABLE `company_info` DISABLE KEYS */;
INSERT INTO `company_info` VALUES (1,'ООО \"Ромашка\"','','','','','','','','','','','','','','','','','','');
/*!40000 ALTER TABLE `company_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `i18n`
--

DROP TABLE IF EXISTS `i18n`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `i18n` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `culture` varchar(2) DEFAULT NULL,
  `language` varchar(45) DEFAULT NULL,
  `description` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `i18n`
--

LOCK TABLES `i18n` WRITE;
/*!40000 ALTER TABLE `i18n` DISABLE KEYS */;
INSERT INTO `i18n` VALUES (1,'en','en-US',NULL),(2,'ru','ru-RU','');
/*!40000 ALTER TABLE `i18n` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item`
--

DROP TABLE IF EXISTS `item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(45) DEFAULT NULL,
  `description` varchar(1000) DEFAULT NULL,
  `category` int(11) DEFAULT NULL,
  `brand` int(11) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_category_idx` (`category`),
  KEY `fk_brand_idx` (`brand`),
  CONSTRAINT `fk_brand` FOREIGN KEY (`brand`) REFERENCES `brands` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_category` FOREIGN KEY (`category`) REFERENCES `item_category` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=59 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item`
--

LOCK TABLES `item` WRITE;
/*!40000 ALTER TABLE `item` DISABLE KEYS */;
INSERT INTO `item` VALUES (14,'ТОВ-000001','Двухъярусная кровать детская ТриЯ Прованс СМ-223.11.001',11,3,NULL,NULL),(15,'ТОВ-000002','Двухъярусная кровать детская ТриЯ Оксфорд СМ-139.11.02',11,3,NULL,'2022-09-11 18:04:51'),(16,'ТОВ-000003','Кровать ТриЯ Адель двуспальная',11,3,NULL,NULL),(17,'ТОВ-000004','Двухъярусная кровать детская ТриЯ Брауни',11,3,NULL,NULL),(18,'ТОВ-000005','Кровать ТриЯ Либерти двуспальная',11,3,NULL,NULL),(19,'ТОВ-000006','Кровать ТриЯ Лорена двуспальная',11,3,NULL,NULL),(20,'ТОВ-000007','Кровать ТриЯ Прованс двуспальная',11,3,NULL,NULL),(21,'ТОВ-000008','Кровать ТриЯ Сабрина с подъемным механизмом двуспальная',11,3,NULL,NULL),(22,'ТОВ-000009','Кровать ТриЯ Фьюжн двухспальная',11,3,NULL,NULL),(23,'ТОВ-000010','Кровать ТриЯ Саванна с подъемным механизмом двуспальная',11,3,NULL,NULL),(24,'ТОВ-000011','Кровать ТриЯ Фьюжн с подъемным механизмом двухспальная',11,3,NULL,NULL),(25,'ТОВ-000012','Кровать детская ТриЯ Ариэль односпальная',12,3,NULL,NULL),(26,'ТОВ-000013','Кровать детская ТриЯ Ариэль односпальная',12,3,NULL,NULL),(27,'ТОВ-000014','Кровать детская ТриЯ Ривьера односпальная',12,3,NULL,NULL),(28,'ТОВ-000015','Кровать детская ТриЯ Сабрина односпальная',12,3,NULL,NULL),(29,'ТОВ-000016','Кровать детская ТриЯ Оксфорд односпальная',12,3,NULL,NULL),(30,'ТОВ-000017','Кровать детская ТриЯ Навигатор односпальная',12,3,NULL,NULL),(31,'ТОВ-000018','Кровать детская ТриЯ Лючия односпальная',12,3,NULL,NULL),(32,'ТОВ-000019','Двухъярусная кровать детская ТриЯ Прованс ТД-223.11.01',12,3,NULL,NULL),(33,'ТОВ-000020','Двухъярусная кровать детская ТриЯ Прованс СМ-223.11.002',12,3,NULL,NULL),(56,'ТОВ-000021','',NULL,NULL,'2022-09-11 18:05:37','2022-09-11 18:06:16'),(57,'ТОВ-000023',NULL,NULL,NULL,'2022-09-11 18:10:51',NULL),(58,'ТВ-001',NULL,NULL,NULL,'2022-09-11 18:11:57',NULL);
/*!40000 ALTER TABLE `item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_category`
--

DROP TABLE IF EXISTS `item_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(45) DEFAULT NULL,
  `description` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_category`
--

LOCK TABLES `item_category` WRITE;
/*!40000 ALTER TABLE `item_category` DISABLE KEYS */;
INSERT INTO `item_category` VALUES (1,'ДЕТКОМОДЫ','Детские комоды'),(2,'КОМОДЫ','Комоды'),(11,'КРОВАТИ','Кровати'),(12,'ДЕТКРОВАТКИ','Кроватки детские'),(13,'ОРГДЛЯКР','Органайзеры и карманы в кроватку'),(14,'ДИВКУШ','Мягкие диваны и кушетки'),(15,'САДДИВАНЫ','Садовые диваны');
/*!40000 ALTER TABLE `item_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_settings`
--

DROP TABLE IF EXISTS `item_settings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_settings` (
  `id` int(11) NOT NULL,
  `item_no_series` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_item_settings_1_idx` (`item_no_series`),
  CONSTRAINT `fk_item_settings_1` FOREIGN KEY (`item_no_series`) REFERENCES `no_series` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_settings`
--

LOCK TABLES `item_settings` WRITE;
/*!40000 ALTER TABLE `item_settings` DISABLE KEYS */;
INSERT INTO `item_settings` VALUES (1,2);
/*!40000 ALTER TABLE `item_settings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `location`
--

DROP TABLE IF EXISTS `location`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `location` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(45) DEFAULT NULL,
  `description` varchar(450) DEFAULT NULL,
  `address` varchar(1000) DEFAULT NULL,
  `phone` varchar(45) DEFAULT NULL,
  `email` varchar(45) DEFAULT NULL,
  `transit` tinyint(4) DEFAULT '0',
  `zone_storage` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `location`
--

LOCK TABLES `location` WRITE;
/*!40000 ALTER TABLE `location` DISABLE KEYS */;
INSERT INTO `location` VALUES (1,'ГЛАВНЫЙ','Основной склад','','','',NULL,1),(2,'ТРАНЗИТ','Склад временного хранения','','','',1,NULL);
/*!40000 ALTER TABLE `location` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menu`
--

DROP TABLE IF EXISTS `menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) DEFAULT NULL,
  `showname` varchar(45) DEFAULT NULL,
  `parent` int(11) DEFAULT NULL,
  `link` varchar(200) DEFAULT NULL,
  `admin_only` tinyint(4) DEFAULT '0',
  `orderitems` int(11) DEFAULT NULL,
  `icon` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=100099 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu`
--

LOCK TABLES `menu` WRITE;
/*!40000 ALTER TABLE `menu` DISABLE KEYS */;
INSERT INTO `menu` VALUES (2,'administration','Администрирование',NULL,'',0,100,'administration'),(5,'menusettings','Настройки меню',2,'menusettings',1,101,'menusettings'),(8,'usersettings','Пользователи',2,'users',0,103,'users'),(14,'roles','Роли',2,'roles',1,102,'usergroup'),(24,'viewsettings','Пользователь настройки',99999,'viewsettings',0,100000,'settings'),(99999,'settings','Настройки',NULL,'',0,99999,'advancedsettings'),(100000,'setup','Установки',NULL,'',0,88888,'settings'),(100001,'unitsofmeasure','Единицы измерения',100000,'uom',0,100101,''),(100028,'development','Разработка',2,'',1,104,'development'),(100029,'forms','Формы',100028,'forms',1,NULL,'form'),(100030,'classes','Классы',100028,'classes',1,NULL,'classes'),(100031,'tables','Таблицы',100028,'tables',1,NULL,'datatable'),(100056,'company_info','Информация о компании',100000,'company_info',0,NULL,'info'),(100057,'settings','Настройки',100048,'',0,200,'settings'),(100065,'reports','Отчеты',100028,'reports',1,NULL,'report-icon'),(100084,'no_series','Серии номеров',100000,'no_series',0,NULL,''),(100088,'items','Товары',NULL,'',0,300,'box'),(100089,'item_categories','Категории',100088,'item_category',0,310,''),(100090,'item_list','Товары',100088,'items',0,320,'box'),(100091,'item_settings','Настройки',100088,'item_settings',0,390,'settings'),(100092,'brands','Производители',100088,'brands',0,330,'brand'),(100093,'warehouse_management','Складской учет',NULL,'',0,400,'Home-icon'),(100094,'locations','Склады',100093,'locations',0,410,'warehouse'),(100095,'zones','Складские зоны',100093,'zones',0,420,'palet02'),(100096,'bins','Складcкие ячейки',100093,'bins',0,430,'palet04'),(100097,'bintypes','Типы ячеек',100093,'bintypes',0,440,''),(100098,'vendors_puchases','Покупки/Поставщики',NULL,'',0,500,'vendors');
/*!40000 ALTER TABLE `menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menuroles`
--

DROP TABLE IF EXISTS `menuroles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menuroles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menuitem` int(11) DEFAULT NULL,
  `role` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `menuitemfk_idx` (`menuitem`),
  KEY `rolefk_idx` (`role`),
  CONSTRAINT `menuitemfk` FOREIGN KEY (`menuitem`) REFERENCES `menu` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `rolefk` FOREIGN KEY (`role`) REFERENCES `sys_roles` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menuroles`
--

LOCK TABLES `menuroles` WRITE;
/*!40000 ALTER TABLE `menuroles` DISABLE KEYS */;
/*!40000 ALTER TABLE `menuroles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `no_series`
--

DROP TABLE IF EXISTS `no_series`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `no_series` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(100) DEFAULT NULL,
  `description` varchar(450) DEFAULT NULL,
  `starting_no` varchar(100) DEFAULT NULL,
  `ending_no` varchar(450) DEFAULT NULL,
  `last_no_used` varchar(450) DEFAULT NULL,
  `increment` int(11) DEFAULT NULL,
  `starts_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `code_UNIQUE` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `no_series`
--

LOCK TABLES `no_series` WRITE;
/*!40000 ALTER TABLE `no_series` DISABLE KEYS */;
INSERT INTO `no_series` VALUES (1,'ТОВАРЫ','Нумерация товаров','ТОВ-0000001','ТОВ-9999999','ТОВ-000023',1,'2022-09-11 00:00:00'),(2,'ТОВАРЫ2','Другая нумерация','ТВ-001','ТВ-999','ТВ-001',1,NULL);
/*!40000 ALTER TABLE `no_series` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_classes`
--

DROP TABLE IF EXISTS `sys_classes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_classes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_classes`
--

LOCK TABLES `sys_classes` WRITE;
/*!40000 ALTER TABLE `sys_classes` DISABLE KEYS */;
INSERT INTO `sys_classes` VALUES (1,'exportutils'),(2,'imageclass'),(6,'importclass'),(9,'noseriesmanagement'),(11,'dateformulas');
/*!40000 ALTER TABLE `sys_classes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_form_states`
--

DROP TABLE IF EXISTS `sys_form_states`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_form_states` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) DEFAULT NULL,
  `form` varchar(45) DEFAULT NULL,
  `state` longtext,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_form_states`
--

LOCK TABLES `sys_form_states` WRITE;
/*!40000 ALTER TABLE `sys_form_states` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_form_states` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_forms`
--

DROP TABLE IF EXISTS `sys_forms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_forms` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) DEFAULT NULL,
  `template` varchar(45) DEFAULT NULL,
  `source` longtext,
  `notfound` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_UNIQUE` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=146 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_forms`
--

LOCK TABLES `sys_forms` WRITE;
/*!40000 ALTER TABLE `sys_forms` DISABLE KEYS */;
INSERT INTO `sys_forms` VALUES (10,'i18n','',NULL,0),(30,'uom','',NULL,0),(31,'viewsettings','',NULL,0),(37,'classes','dev',NULL,0),(38,'tables','dev',NULL,0),(39,'forms','dev',NULL,0),(59,'company_info','',NULL,NULL),(66,'reports','dev',NULL,NULL),(73,'no_series','',NULL,NULL),(77,'roles',NULL,NULL,NULL),(78,'users',NULL,NULL,NULL),(137,'menusettings','',NULL,0),(138,'item_category','',NULL,NULL),(139,'items','',NULL,NULL),(140,'item_settings','',NULL,NULL),(141,'brands','',NULL,NULL),(142,'locations','',NULL,NULL),(143,'zones','',NULL,NULL),(144,'bins','',NULL,NULL),(145,'bintypes','',NULL,NULL);
/*!40000 ALTER TABLE `sys_forms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_reports`
--

DROP TABLE IF EXISTS `sys_reports`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_reports` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) DEFAULT NULL,
  `template` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_reports`
--

LOCK TABLES `sys_reports` WRITE;
/*!40000 ALTER TABLE `sys_reports` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_reports` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_role_menuitems`
--

DROP TABLE IF EXISTS `sys_role_menuitems`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_role_menuitems` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `roleid` int(11) DEFAULT NULL,
  `menuitemid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `index2` (`roleid`,`menuitemid`),
  KEY `sys_rm_menuitemidx_idx` (`menuitemid`),
  CONSTRAINT `sys_rm_menuitemidx` FOREIGN KEY (`menuitemid`) REFERENCES `menu` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `sys_rm_roleidx` FOREIGN KEY (`roleid`) REFERENCES `sys_roles` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=107 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_role_menuitems`
--

LOCK TABLES `sys_role_menuitems` WRITE;
/*!40000 ALTER TABLE `sys_role_menuitems` DISABLE KEYS */;
INSERT INTO `sys_role_menuitems` VALUES (12,3,24),(13,3,99999),(15,4,2),(17,4,5),(19,4,8),(20,4,14),(22,4,24),(27,4,99999),(28,4,100000),(29,4,100001),(50,4,100028),(51,4,100029),(52,4,100030),(53,4,100031),(78,4,100056),(79,4,100057),(87,4,100065),(106,4,100084);
/*!40000 ALTER TABLE `sys_role_menuitems` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_roles`
--

DROP TABLE IF EXISTS `sys_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_roles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `description` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_roles`
--

LOCK TABLES `sys_roles` WRITE;
/*!40000 ALTER TABLE `sys_roles` DISABLE KEYS */;
INSERT INTO `sys_roles` VALUES (1,'Администрирование'),(3,'Настройки'),(4,'Все, кроме администрирования');
/*!40000 ALTER TABLE `sys_roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_roles_tables`
--

DROP TABLE IF EXISTS `sys_roles_tables`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_roles_tables` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `roleid` int(11) DEFAULT NULL,
  `tableid` int(11) DEFAULT NULL,
  `allow_select` tinyint(4) DEFAULT '0',
  `allow_update` tinyint(4) DEFAULT '0',
  `allow_delete` tinyint(4) DEFAULT '0',
  `allow_insert` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `role_table` (`roleid`,`tableid`),
  KEY `table_refid_idx` (`tableid`),
  CONSTRAINT `role_refid` FOREIGN KEY (`roleid`) REFERENCES `sys_roles` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `table_refid` FOREIGN KEY (`tableid`) REFERENCES `sys_tables` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=133 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_roles_tables`
--

LOCK TABLES `sys_roles_tables` WRITE;
/*!40000 ALTER TABLE `sys_roles_tables` DISABLE KEYS */;
INSERT INTO `sys_roles_tables` VALUES (11,3,110,1,1,0,0),(12,3,104,1,0,0,0),(15,3,158,1,0,0,0),(33,4,92,1,0,0,0),(34,4,93,1,0,0,0),(41,4,100,1,0,0,0),(43,4,102,1,0,0,0),(44,4,103,1,0,0,0),(45,4,104,1,0,0,0),(48,4,107,1,1,1,1),(51,4,110,1,1,1,1),(53,4,149,1,0,0,0),(54,4,150,1,0,0,0),(55,4,151,1,0,0,0),(62,4,158,1,0,0,0),(77,4,173,1,0,0,0),(78,4,174,1,0,0,0),(96,4,192,1,1,1,1),(118,4,215,1,0,0,0),(119,4,216,1,0,0,0),(120,4,217,1,0,0,0),(125,4,222,1,1,1,1),(132,4,229,1,0,0,0);
/*!40000 ALTER TABLE `sys_roles_tables` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_tables`
--

DROP TABLE IF EXISTS `sys_tables`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_tables` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) DEFAULT NULL,
  `extended` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=233 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_tables`
--

LOCK TABLES `sys_tables` WRITE;
/*!40000 ALTER TABLE `sys_tables` DISABLE KEYS */;
INSERT INTO `sys_tables` VALUES (92,'menu',NULL),(93,'menuroles',NULL),(100,'roles',NULL),(102,'sys_roles_tables',NULL),(103,'sys_tables',NULL),(104,'themes',NULL),(107,'unitofmeasure',NULL),(110,'viewsettings',NULL),(149,'sys_roles',NULL),(150,'sys_user_roles',NULL),(151,'sys_role_menuitems',NULL),(158,'i18n',NULL),(173,'sys_classes',NULL),(174,'sys_forms',NULL),(192,'company_info',NULL),(215,'sys_form_states',NULL),(216,'sys_form_tips',NULL),(217,'sys_reports',NULL),(222,'no_series',NULL),(229,'sys_users',NULL),(230,'item',NULL),(231,'item_category',NULL);
/*!40000 ALTER TABLE `sys_tables` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_user_roles`
--

DROP TABLE IF EXISTS `sys_user_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_user_roles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) DEFAULT NULL,
  `role` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `user_idx` (`user`),
  KEY `role_idx` (`role`),
  CONSTRAINT `role` FOREIGN KEY (`role`) REFERENCES `sys_roles` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `user` FOREIGN KEY (`user`) REFERENCES `sys_users` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_user_roles`
--

LOCK TABLES `sys_user_roles` WRITE;
/*!40000 ALTER TABLE `sys_user_roles` DISABLE KEYS */;
INSERT INTO `sys_user_roles` VALUES (4,2,3),(5,4,4),(6,5,4),(7,6,4),(8,7,4),(9,8,4),(10,9,4),(11,10,4),(12,11,4),(13,12,4),(14,13,4),(16,14,4);
/*!40000 ALTER TABLE `sys_user_roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_users`
--

DROP TABLE IF EXISTS `sys_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(32) DEFAULT NULL,
  `password` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_users`
--

LOCK TABLES `sys_users` WRITE;
/*!40000 ALTER TABLE `sys_users` DISABLE KEYS */;
INSERT INTO `sys_users` VALUES (1,'admin','e10adc3949ba59abbe56e057f20f883e'),(2,'user','c4ca4238a0b923820dcc509a6f75849b'),(4,'demouser','e10adc3949ba59abbe56e057f20f883e'),(5,'demouser1','e10adc3949ba59abbe56e057f20f883e'),(6,'demouser2','e10adc3949ba59abbe56e057f20f883e'),(7,'demouser3','e10adc3949ba59abbe56e057f20f883e'),(8,'demouser4','e10adc3949ba59abbe56e057f20f883e'),(9,'demouser5','e10adc3949ba59abbe56e057f20f883e'),(10,'demouser6','e10adc3949ba59abbe56e057f20f883e'),(11,'demouser7','e10adc3949ba59abbe56e057f20f883e'),(12,'demouser8','e10adc3949ba59abbe56e057f20f883e'),(13,'demouser9','e10adc3949ba59abbe56e057f20f883e'),(14,'demouser10','e10adc3949ba59abbe56e057f20f883e');
/*!40000 ALTER TABLE `sys_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `themes`
--

DROP TABLE IF EXISTS `themes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `themes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `theme_name` varchar(45) DEFAULT NULL,
  `description` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `themes`
--

LOCK TABLES `themes` WRITE;
/*!40000 ALTER TABLE `themes` DISABLE KEYS */;
INSERT INTO `themes` VALUES (1,'base','Базовая'),(2,'bootstrap','Бело-голубая'),(3,'dark','Темно-синяя'),(4,'energyblue','Светло-синяя'),(5,'darkmint','Темно-мятная'),(6,'office','Светло-мятная');
/*!40000 ALTER TABLE `themes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `unitofmeasure`
--

DROP TABLE IF EXISTS `unitofmeasure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `unitofmeasure` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(45) DEFAULT NULL,
  `description` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `unitofmeasure`
--

LOCK TABLES `unitofmeasure` WRITE;
/*!40000 ALTER TABLE `unitofmeasure` DISABLE KEYS */;
INSERT INTO `unitofmeasure` VALUES (1,'КГ','Килограмм'),(2,'ГР','Грамм'),(3,'М','Метр'),(4,'ШТ','Штука'),(5,'Л','Литр'),(6,'Д','День'),(7,'Ч','Час');
/*!40000 ALTER TABLE `unitofmeasure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `viewsettings`
--

DROP TABLE IF EXISTS `viewsettings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `viewsettings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) DEFAULT NULL,
  `themeid` int(11) DEFAULT NULL,
  `altrows` tinyint(4) DEFAULT NULL,
  `i18n` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `userkey_idx` (`userid`),
  KEY `themekey_idx` (`themeid`),
  KEY `user_i18n_idx` (`i18n`),
  CONSTRAINT `themekey` FOREIGN KEY (`themeid`) REFERENCES `themes` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `user_i18n` FOREIGN KEY (`i18n`) REFERENCES `i18n` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `userkey` FOREIGN KEY (`userid`) REFERENCES `sys_users` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=23 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `viewsettings`
--

LOCK TABLES `viewsettings` WRITE;
/*!40000 ALTER TABLE `viewsettings` DISABLE KEYS */;
INSERT INTO `viewsettings` VALUES (1,1,5,0,2),(2,2,NULL,1,1),(3,4,NULL,0,1),(13,5,NULL,NULL,1),(14,7,NULL,NULL,1),(15,8,NULL,NULL,1),(16,9,NULL,NULL,1),(17,10,NULL,NULL,1),(18,11,NULL,NULL,1),(19,12,NULL,NULL,1),(20,13,NULL,0,1),(21,6,NULL,NULL,1),(22,14,NULL,NULL,NULL);
/*!40000 ALTER TABLE `viewsettings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zone`
--

DROP TABLE IF EXISTS `zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zone` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(45) DEFAULT NULL,
  `description` varchar(45) DEFAULT NULL,
  `location` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_zone_1_idx` (`location`),
  CONSTRAINT `fk_zone_1` FOREIGN KEY (`location`) REFERENCES `location` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zone`
--

LOCK TABLES `zone` WRITE;
/*!40000 ALTER TABLE `zone` DISABLE KEYS */;
INSERT INTO `zone` VALUES (1,'ПРИЕМКА','Зона приемки',1),(2,'ХРАНЕНИЕ','Зона хранения',1),(3,'ОТГРУЗКА','Зона отгрузки',1);
/*!40000 ALTER TABLE `zone` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2022-09-15 21:43:51
